/*
   Copyright (C) 2007 - 2009 by Roberto García Carvajal <roberpot@gmail.com>
   Part of libglsws (http://magiccards.wordpress.com)

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License version 3
   or at your option any later version.
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY.

   See the COPYING file for more details.
*/

#include <GL/gl.h>
#include "c_oventana.h"


/*******************************************************************************
*
* Método constructor.
* Recibe un entero sin signo de 32 bits a modo de banderas.
* Inicializa los datos.
*
*******************************************************************************/
c_oboton::c_oboton(GLuint rbe)
{
 _o_x = 10;
 _o_y = 10;
 _o_ancho = 10;
 _o_alto = 10;
 _RBE = rbe;
 _o_colorf[0] = 0.70;
 _o_colorf[1] = 0.70;
 _o_colorf[2] = 0.70;
 _o_colorb[0] = 0.00;
 _o_colorb[1] = 0.00;
 _o_colorb[2] = 0.00;
 _o_tipo = O_T_BOTON;
 // FIX-ME FALTAN DATOS POR INICIALIZAR.
}

/*******************************************************************************
*
* Método dibujar.
* Recibe dos flotantes x e y.
* Renderiza el objeto a partir de x e y.
*
*******************************************************************************/
void c_oboton::dibujar(GLfloat x,GLfloat y)
{
 // Colocamos una nueva matriz en la pila, para no afectar a la anterior.
 glPushMatrix();
 // Nos trasladamos a la posición correcta.
 glTranslatef(x+_o_x,y+_o_y,0.0);
 // Sólo lo dibujamos si es visible.
 if(_RBE & O_VISIBLE)
 {
  // Si es texturado...
  if(_RBE & O_TEXTURADO)
  {
   // Bindeamos la textura, las habilitamos y lo dibujamos.
   glEnable(GL_TEXTURE_2D);
   //glBindTexture(GL_TEXTURE_2D,_o_texto);
   // FIX-ME: no funcionan las texturas.
   glBegin(GL_QUADS);
    glTexCoord2f(0.0, 1.0); glVertex2f(0, 0);
    glTexCoord2f(0.0, 0.0); glVertex2f(0, _o_alto);
    glTexCoord2f(1.0, 0.0); glVertex2f(_o_ancho, _o_alto);
    glTexCoord2f(1.0, 1.0); glVertex2f(_o_ancho, 0);
   glEnd();
   glDisable(GL_TEXTURE_2D);
  }
  else
  {
   // Si no es texturado elegimos el color de fondo y lo dibujamos
   glColor3fv(_o_colorf);
   glBegin(GL_QUADS);
    glVertex2f(0, 0);
    glVertex2f(0, _o_alto);
    glVertex2f(_o_ancho, _o_alto);
    glVertex2f(_o_ancho, 0);
   glEnd();
   // Idem con el borde.
   glColor3fv(_o_colorb);
   glBegin(GL_LINE_LOOP);
    glVertex2f(0, 0);
    glVertex2f(0, _o_alto);
    glVertex2f(_o_ancho, _o_alto);
    glVertex2f(_o_ancho, 0);
   glEnd();
   // Y ahora dibujamos el texto. Añadimos otra matriz a la pila y nos movemos a
   // la posición correcta para dibujarlo al centro.
   glColor3fv(_o_colort);
   glPushMatrix();
   glTranslatef(_o_posicionCentradaHorizontal,_o_posicionCentradaVertical,0.0);
   // Elegimos el color, el tamaño y renderizamos.
   glColor3fv(_o_colort);
   _fuente->FaceSize(_o_textoTamano);
   _fuente->Render(_o_texto.c_str());
   glPopMatrix();
  }
 }
 glPopMatrix();
}

/*******************************************************************************
*
* Método guardar.
* Devuelve el dato asociado.
*
*******************************************************************************/
c_dato c_oboton::guardar()
{
 c_dato d;
 d.sets(_o_texto);
 return d;
}


/*******************************************************************************
*
* Método destructor.
*
*******************************************************************************/
c_oboton::~c_oboton()
{
}
