/*
   Copyright (C) 2007 - 2009 by Roberto García Carvajal <roberpot@gmail.com>
   Part of libglsws (http://magiccards.wordpress.com)

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License version 3
   or at your option any later version.
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY.

   See the COPYING file for more details.
*/

#include <GL/gl.h>
#include <iostream>
#include "c_oventana.h"

using namespace std;

/*******************************************************************************
*
* Constructor
* Recibe un entero sin signo de 32 bits a modo de registro de banderas.
* Inicializa todas las variables internas.
*
*******************************************************************************/
c_otextoeditable::c_otextoeditable(GLuint rbe)
{
 _o_x = 10;
 _o_y = 10;
 _o_ancho = 10;
 _o_alto = 10;
 _RBE = rbe;
 _o_colorf[0] = 0.70;
 _o_colorf[1] = 0.70;
 _o_colorf[2] = 0.70;
 _o_colorb[0] = 0.00;
 _o_colorb[1] = 0.00;
 _o_colorb[2] = 0.00;
 _o_tipo = O_T_TEXTOEDITABLE;
 // FIX-ME faltan variables por inicializar.
}

/*******************************************************************************
*
* Método dibujar.
* Recibe dos flotantes x e y.
* Renderiza el objeto.
*
*******************************************************************************/
void c_otextoeditable::dibujar(GLfloat x,GLfloat y)
{
 // Lo hago en otra matriz sobre la pila.
 glPushMatrix();
 glTranslatef(x+_o_x,y+_o_y,0.0);
 // Si el objeto es visible...
 if(_RBE & O_VISIBLE)
 {
  // Si está texturado...
  if(_RBE & O_TEXTURADO)
  {
   // Habilito las texturas, selecciono la textura y lo renderizo.
   glEnable(GL_TEXTURE_2D);
   //glBindTexture(GL_TEXTURE_2D,_o_texto);
   glBegin(GL_QUADS);
    glTexCoord2f(0.0, 1.0); glVertex2f(0, 0);
    glTexCoord2f(0.0, 0.0); glVertex2f(0, _o_alto);
    glTexCoord2f(1.0, 0.0); glVertex2f(_o_ancho, _o_alto);
    glTexCoord2f(1.0, 1.0); glVertex2f(_o_ancho, 0);
   glEnd();
   glDisable(GL_TEXTURE_2D);
   // Dibujo el texto.
   glColor3fv(_o_colort);
   glPushMatrix();
   glTranslatef(1,_o_posicionCentradaVertical,0.0);
   glColor3fv(_o_colort);
   _fuente->FaceSize(_o_textoTamano);
   _fuente->Render(_o_texto.c_str());
   glPopMatrix();
  }
  else
  {
   // Si no es texturado elijo el color de fondo y lo dibujo.
   glColor3fv(_o_colorf);
   glBegin(GL_QUADS);
    glVertex2f(0, 0);
    glVertex2f(0, _o_alto);
    glVertex2f(_o_ancho, _o_alto);
    glVertex2f(_o_ancho, 0);
   glEnd();
   glColor3fv(_o_colorb);
   glBegin(GL_LINE_LOOP);
    glVertex2f(0, 0);
    glVertex2f(0, _o_alto);
    glVertex2f(_o_ancho, _o_alto);
    glVertex2f(_o_ancho, 0);
   glEnd();
   glColor3fv(_o_colort);
   glPushMatrix();
   glTranslatef(1,_o_posicionCentradaVertical,0.0);
   glColor3fv(_o_colort);
   _fuente->FaceSize(_o_textoTamano);
   _fuente->Render(_o_texto.c_str());
   glPopMatrix();
  }
 }
 glPopMatrix();
}

/*******************************************************************************
*
* Método cargar.
* Recibe un dato.
* Procesa el dato.
*
*******************************************************************************/
void c_otextoeditable::cargar(c_dato d)
{
 if(d.t_dato() == _T_DATO_STRING)
 {
  _o_texto = d.s();
 }
}

/*******************************************************************************
*
* Método guardar.
* Devuelve el dato asociado.
*
*******************************************************************************/
c_dato c_otextoeditable::guardar()
{
 c_dato d;
 d.sets(_o_texto);
 return d;
}

/*******************************************************************************
*
* Destructor.
*
*******************************************************************************/
c_otextoeditable::~c_otextoeditable()
{
}
